;*************************************************************************************
;   mlba5.lsp K. A. Kubat / 04.2021
;   erstellt eine Multifhrungslinie mit Schriftfeldbezug
;   zu folgenden Attributen eines Blockes
;   NR.
;   BEZEICHNUNG
;   PROFIL, GTE
;   ABMESSUNG
;   Layer: T__TEXT
;*************************************************************************************

(defun c:mlba5 ( / at1 at2 at3 at4 at5 ent enx ins lst mld pnt )

    	  ;;;--------------------Layer
    (setvar "cmdecho" 0)					
  (setq cln (getvar "clayer"))				
  	(command-s "_.-layer" "_make" "T__TEXT" "")	
(setvar "cmdecho" 1)
  

		   	  ;;;--------------------Block whlen

   (while
    (progn
      (setvar 'errno 0)
      (setq ent (car (entsel "\nWhle Block <Abbruch>: ")))
      (cond
        (  (= 7 (getvar 'errno))
          (princ "\nNichts gewhlt, Versuch es nochmal.")
        )
        (  (null ent)
          nil
        )
        (  (/= "INSERT" (cdr (assoc 0 (setq enx (entget ent)))))
          (princ "\nObject ist kein Block.")
        )
        (  (/= 1 (cdr (assoc 66 enx)))
          (princ "\nBlock hat keine Attribute.")
        )
        (  (not
            (and
              (setq lst (vlax-invoke (vlax-ename->vla-object ent) 'getattributes)
                 lst (mapcar '(lambda ( x ) (cons (strcase (vla-get-tagstring x)) x)) lst)
              )
                             (setq at1 (cdr (assoc "NR." lst)))
                            (setq at2 (cdr (assoc "BEZEICHNUNG"  lst)))
			    (setq at3 (cdr (assoc "PROFIL"  lst)))
			    (setq at4 (cdr (assoc "GTE"  lst)))
			    (setq at5 (cdr (assoc "ABMESSUNG"  lst)))
            )
          )
          (princ "\
			   \nFalscher Block, mind. ein Attribut
			   \n( NR. - BEZEICHNUNG - PROFIL - GTE )
			   \nnicht im Block enthalten.
			   ")
        )
        (  (and
            (= "" (vla-get-textstring at1))
            (= "" (vla-get-textstring at2))
 			(= "" (vla-get-textstring at3))
			(= "" (vla-get-textstring at4))
			(= "" (vla-get-textstring at5))
          )
          (princ "\nBeide Attribute sind leer.")
        )
        ( 
		 


		   	  ;;;--------------------Punkte whlen
  (setq lpt1 (getpoint "\nPosition fr Fhrungslinienpfeilspitze angeben..: "))
  (setq lpt2 (getpoint lpt1 "\nNchsten Punkt zeigen..: "))

  	  ;;;--------------------Multifhrungslinie erstellen 


		 (setvar "cmdecho" 0)
    (command-s "_mleader" "_options" "_maxpoints" "2" "_exit" lpt1 lpt2
		 

            (strcat
              (if (= "" (vla-get-textstring at1))
                ""
                (strcat
                  "%<\\AcObjProp Object(%<\\_ObjId "
                  (LM:ObjectID at1)
                  ">%).TextString>%"
                  (if (= "" (vla-get-textstring at2)) "" "\n")
                )
              )
              (if (= "" (vla-get-textstring at2))
                ""
                (strcat
                  "%<\\AcObjProp Object(%<\\_ObjId "
                  (LM:ObjectID at2)
                  ">%).TextString>%"
                                    (if (= "" (vla-get-textstring at3)) "" "\n")
                                )
                            )
			    (if (= "" (vla-get-textstring at3))
                                ""
                                (strcat
                                    "%<\\AcObjProp Object(%<\\_ObjId "
                                    (LM:ObjectID at3)
                                    ">%).TextString>%"
                                    (if (= "" (vla-get-textstring at4)) "" ", ")
                                )
                            )
			    (if (= "" (vla-get-textstring at4))
                                ""
                                (strcat
                                    "%<\\AcObjProp Object(%<\\_ObjId "
                                    (LM:ObjectID at4)
                                    ">%).TextString>%"
                                    (if (= "" (vla-get-textstring at5)) "" "\n")
                                )
                            )
                            (if (= "" (vla-get-textstring at5))
                                ""
                                (strcat
                                    "%<\\AcObjProp Object(%<\\_ObjId "
                                    (LM:ObjectID at5)
                                    ">%).TextString>%"
                )
              )
            )
          )
		 )
        )
      )
    )
  
  (setvar "clayer" cln)
(setvar "cmdecho" 1)
  (princ)
)

;; ObjectID - Lee Mac
;; Returns a string containing the ObjectID of a supplied VLA-Object
;; Compatible with 32-bit & 64-bit systems

(defun LM:ObjectID ( obj )
  (eval
    (list 'defun 'LM:ObjectID '( obj )
      (if
        (and
          (vl-string-search "64" (getenv "PROCESSOR_ARCHITECTURE"))
          (vlax-method-applicable-p (vla-get-utility (LM:acdoc)) 'getobjectidstring)
        )
        (list 'vla-getobjectidstring (vla-get-utility (LM:acdoc)) 'obj ':vlax-false)
        '(itoa (vla-get-objectid obj))
      )
    )
  )
  (LM:ObjectID obj)
)

;; Active Document - Lee Mac
;; Returns the VLA Active Document Object

(defun LM:acdoc nil
  (eval (list 'defun 'LM:acdoc 'nil (vla-get-activedocument (vlax-get-acad-object))))
  (LM:acdoc)
)

(vl-load-com) (princ)
