;****************************************************
;   mlba.lsp von K. A. Kubat 07/2015,
;   Multi-Linie Bezeichnung Abmessung
;
;   Extrahiert aus Blockreferenz eine Multifhrungslinie
;   mit Schriftfeld Bezug zu den Attributen
;   "Bezeichnung" und "Abmessung" diese mssen
;   im Block enthalten sein
;   Ein Attribut darf auch leer sein
;   Dann wird nur ein Wert in die MF-Linie bernmmen
;
;   Verwendet aktuell eingestellten Mulitfhrungsstil
;   Achtung im Multifhrungslinienstil muss die
;   "Maxim.Fhrungslinien-Punkte" Wert = 2 sein
;   wenn mehr erfolgt keine Textbernahme
;
;   06-11-2018
;   berarbeitung
;****************************************************

(defun c:mlba ( / at1 at2 ent enx ins lst mld pnt )

    	  ;;;--------------------Layer
    (setvar "cmdecho" 0)					
  (setq cln (getvar "clayer"))				
  	(command-s "_.-layer" "_make" "T__TEXT" "")	
(setvar "cmdecho" 1)
  

		   	  ;;;--------------------Block whlen

   (while
    (progn
      (setvar 'errno 0)
      (setq ent (car (entsel "\nWhle Block <Abbruch>: ")))
      (cond
        (  (= 7 (getvar 'errno))
          (princ "\nNichts gewhlt, Versuch es nochmal.")
        )
        (  (null ent)
          nil
        )
        (  (/= "INSERT" (cdr (assoc 0 (setq enx (entget ent)))))
          (princ "\nObject ist kein Block.")
        )
        (  (/= 1 (cdr (assoc 66 enx)))
          (princ "\nBlock hat keine Attribute.")
        )
        (  (not
            (and
              (setq lst (vlax-invoke (vlax-ename->vla-object ent) 'getattributes)
                 lst (mapcar '(lambda ( x ) (cons (strcase (vla-get-tagstring x)) x)) lst)
              )
              (setq at1 (cdr (assoc "BEZEICHNUNG" lst)))
              (setq at2 (cdr (assoc "ABMESSUNG" lst)))
            )
          )
          (princ "\nKeine Attribute mit Namen \"Bezeichnung\" & \"Abmessung\" im Block.")
        )
        (  (and
            (= "" (vla-get-textstring at1))
            (= "" (vla-get-textstring at2))
          )
          (princ "\nBeide Attribute sind leer.")
        )
        ( 
		 


		   	  ;;;--------------------Punkte whlen
  (setq lpt1 (getpoint "\nPosition fr Fhrungslinienpfeilspitze angeben..: "))
  (setq lpt2 (getpoint lpt1 "\nNchsten Punkt zeigen..: "))

  	  ;;;--------------------Multifhrungslinie erstellen 


		 (setvar "cmdecho" 0)
    (command-s "_mleader" "_options" "_maxpoints" "2" "_exit" lpt1 lpt2
		 

            (strcat
              (if (= "" (vla-get-textstring at1))
                ""
                (strcat
                  "%<\\AcObjProp Object(%<\\_ObjId "
                  (LM:ObjectID at1)
                  ">%).TextString>%"
                  (if (= "" (vla-get-textstring at2)) "" "\n")
                )
              )
              (if (= "" (vla-get-textstring at2))
                ""
                (strcat
                  "%<\\AcObjProp Object(%<\\_ObjId "
                  (LM:ObjectID at2)
                  ">%).TextString>%"
                )
              )
            )
          )
		 )
        )
      )
    )
  
  (setvar "clayer" cln)
(setvar "cmdecho" 1)
  (princ)
)

;; ObjectID - Lee Mac
;; Returns a string containing the ObjectID of a supplied VLA-Object
;; Compatible with 32-bit & 64-bit systems

(defun LM:ObjectID ( obj )
  (eval
    (list 'defun 'LM:ObjectID '( obj )
      (if
        (and
          (vl-string-search "64" (getenv "PROCESSOR_ARCHITECTURE"))
          (vlax-method-applicable-p (vla-get-utility (LM:acdoc)) 'getobjectidstring)
        )
        (list 'vla-getobjectidstring (vla-get-utility (LM:acdoc)) 'obj ':vlax-false)
        '(itoa (vla-get-objectid obj))
      )
    )
  )
  (LM:ObjectID obj)
)

;; Active Document - Lee Mac
;; Returns the VLA Active Document Object

(defun LM:acdoc nil
  (eval (list 'defun 'LM:acdoc 'nil (vla-get-activedocument (vlax-get-acad-object))))
  (LM:acdoc)
)

(vl-load-com) (princ)
